#include <iostream>
#include <string>

#include "linkdb.h"

class copyRequiredMetadata : public rawLinkVisitor
{
	public:
		copyRequiredMetadata( linkDB& input ) : count( 0 ), input( input ) {}
			
		virtual void visit( linkDB* output, const md5sum& src, const md5sum& dest )
		{
			string url;
			string title;
			
			/*vector<md5sum> test = output->getLinks( src );
			assert( test.size() > 0 );
			test = output->getLinks( dest );
			assert( test.size() > 0 );*/
			
			// Copy source URL metadata
			input.getURLTitlePair( src, url, title );
			assert( url != "" );
			output->putURL( url, title );
				
			// Copy destination URL metadata
			url = "";
			title = "";
			input.getURLTitlePair( dest, url, title );
			assert( url != "" );
			output->putURL( url, title );
			
			++ count;
			if ( count % 100 == 0 )
			{
				cerr << ".";
				if ( count % 1000 == 0 ) cerr << count << endl;
			}
		}
		
	private:
		unsigned long int count;
		linkDB& input;
};


using std::string;

int main( int argc, char** argv )
{
	// Create a directory for the links:
	const char bidirLinks[] = "/tmp/bidir";
	
	linkDB source( "", true );
	linkDB output( bidirLinks );
	
	copyRequiredMetadata visitor( source );
	output.visitLinks( visitor );
	
	return 0;
}
