#include <iostream>
#include <string>
#include <list>

#include "linkdb.h"

class reverseLinks : public rawLinkVisitor
{
	public:
		reverseLinks() : count( 0 ) {}
			
		virtual void visit( linkDB* output, const md5sum& src, const md5sum& dest )
		{
			// Put the link backwards (it is a bidirectional link)
			//output->link( dest, src );
			outLinks.push_back( pair<md5sum,md5sum>( dest, src ) );
			
			++ count;
			if ( count % 1000 == 0 )
			{
				cerr << ".";
				if ( count % 10000 == 0 ) cerr << count << endl;
			}
		}
		
		void sync( linkDB& output )
		{
			for ( list< pair<md5sum,md5sum> >::const_iterator i = outLinks.begin(); i != outLinks.end(); ++ i )
			{
				
				output.link( i->first, i->second );
			}
		}
		
		// G++ told me to make this destructor virtual
		virtual ~reverseLinks() {}
		
	private:
		list< pair<md5sum,md5sum> > outLinks;
		unsigned long int count;
};


using std::string;

int main( int argc, char** argv )
{
	// The directory for the links
	const char bidirLinks[] = "/tmp/bidir";
	
	linkDB output( bidirLinks );
	
	reverseLinks visitor;
	output.visitLinks( visitor );
	visitor.sync( output );
	
	cerr << endl;
	
	return 0;
}
