#include <iostream>
#include <string>

#include <unistd.h>

#include "linkdb.h"

using std::string;

class printBidirLinks : public linkVisitor
{
	public:
		virtual void visit( const string& src, const string& dest )
		{
			cout << src << "    " << dest << endl;
			cout << dest << "    " << src << endl;
		}
};

void usage()
{
	cout << "./test-bidir-links [options]" << endl
		<< "Options:" << endl
		<< "\t-h -?\tHelp: Show this usage message" << endl
		<< "\t-d <dir>\tDirectory: Use the databases in <dir>" << endl;
}

int main( int argc, char** argv )
{
	string outputPath = "";
	
	// -? : help
	// -h : help
	// -d : Use database in directory ...
	char options[] = "?hd:";
	
	char opt = ' ';
	while ( (opt = getopt( argc, argv, options )) != -1 )
	{
		switch ( opt )
		{
			// Usage
			case 'h':
			case '?':
				usage();
				return 0;
				break;
			
			case 'd':
				outputPath = optarg;
				break;				
		}
	}
	
	linkDB db( outputPath, true );

	printBidirLinks linkPrint;
	db.visitLinks( linkPrint );
	
	return 0;
}
