#include <iostream>
#include <string>

using std::string;

// Resolves any ".." references in a path
string resolvePath( string path )
{
	// Get rid of any leading "../" sequences
	/*
	while( path.substr( 0, 3 ) == "../" )
	{
		path.erase( 0, 3 );
	}
	*/
	
	string::size_type findPos = 0;
	string::size_type pos = string::npos;
	while( (pos = path.find( "../", findPos )) != string::npos )
	{
		// Each time we find a "/../", we erase the "[^/]/" section before it.
		string::size_type erasePos = 0;
		if ( pos >= 2 )
		{
			// Make sure there is a "/" in front
			if ( path[pos - 1] != '/' )
			{
				cout << "Not a /../" << endl;
				findPos = pos + 3;
				continue;
			}
			
			erasePos = path.rfind( "/", pos - 2 );
			if ( erasePos == string::npos )
			{
				cout << "not found" << endl;
				erasePos = 0;
			}
			else	// Keep the slash
				erasePos ++;
		}
		
		cout << "e = " << erasePos << " p = " << pos << endl;
		cout << "erase( " << erasePos << ", " << (pos - erasePos + 3) << " )" << endl;		
		path.erase( erasePos, pos - erasePos + 3 );
		
		// Search for the next "/../" sequence starting at the pont where we erased stuff
	 	findPos = erasePos;
	}

	return path;
}

int main()
{
	// path
	string path( "/../~ejones/software/" );
	
	cout << path << endl;
	cout << resolvePath( path ) << endl;
	
	return 0;
}
